/*
 * pi - P user Interface
 * 
 * $Id: button.c,v 1.1.1.1 2001/02/13 18:30:27 malekith Exp $
 * Author: Michal Moskal <malekith@pld.org.pl>
 * include COPYING-GNU
 */

#include <pi/pi.h>
#include <string.h>

void pi_button_draw(struct pi_object *ctx)
{
	int c1, c2;
	int x, y, n;
	const char *caption;
	
	pi_locate(ctx, &x, &y);
	if (pi_is_active((struct pi_object*)ctx)) {
		c1 = pi_int(color_acct);
		c2 = pi_int(color_acct_hl);
	} else {
		c1 = pi_int(color_norm);
		c2 = pi_int(color_norm_hl);
	}
	
	pi_color(c1);
	pi_putch('[');
	n = ctx->w - 2;
	while (n--)
		pi_putch(' ');
	pi_putch(']');

	caption = pi_ptrd(caption, "");
	
	n = pi_strlen_alt(caption);
	if (n > ctx->w - 2) {
		pi_goto(x + 1, y);
		pi_addstr_alt(caption, ctx->w - 2, c1, c2);
	} else {
		pi_goto(x + (ctx->w - n) / 2, y);
		pi_addstr_alt(caption, -1, c1, c2);
	}
}

int pi_button_key(struct pi_object *ctx, int key)
{
	if (key == ' ' || key == '\n') {
		pi_send_cc(ctx, pi_int(cc));
		return 1;
	} else
		return pi_object_key(ctx, key);
}

struct pi_object *pi_new_button(struct pi_object *ctx, struct pi_object *super)
{
	char *caption;
	
	pi_new_init((0,
			pi_tag_flags, pi_f_can_get_focus,
			pi_tag_key_handler, pi_button_key,
			pi_tag_draw_handler, pi_button_draw,
			pi_tag_cc, 1,
			pi_tag_caption, "_Ok",
			PI_COLOR(norm, green, black),
			PI_COLOR(norm_hl, lightgreen, black),
	0), object);

	caption = pi_ptr(caption);
	pi_set_tag(ret, pi_tag_caption | pi_tf_free, strdup(caption));

	pi_init_size(ret, 0, 0, pi_strlen_alt(caption) + 4, 1);

	pi_copy_int(cc);

	return ret;
}
