/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: utils.h,v 1.7 2000/09/09 17:59:14 malekith Exp $ */

#ifndef _V_UTILS_H
#define _V_UTILS_H

#include <string.h>
#include <stdlib.h>

#include <syslog.h>
#define LOG(a...) syslog(LOG_DEBUG, a)

#define null (0)

class Exception {
	char *err_msg;
	virtual const char *name() = 0; 
protected:
	Exception(const char *s); 
public:
	char *format_self();
	void die();
};

#define XCPT(XName, XBase) \
class XName : public XBase { \
	virtual const char *name() { return #XName ; } \
public: \
	XName(const char *s) : XBase(s) { } \
}

XCPT(XDead, Exception);
XCPT(XRecover, Exception);
XCPT(XError, XRecover);

class Regex;

class XXX {
	unsigned data;
public:
	XXX() : data(0xdeadf00d) {}
	~XXX() { if (data != 0xdeadf00d) abort(); }
};

class String {
//	XXX xxx;
	char *ref;
	void mem();
public:
	String(const String &r);
	String(const char *s = "");
	String(const char *s, int size);
	
	const String & operator = (const String &r)
		{ set(r); return *this; }
	const String & operator += (const String &r);
	~String() { free(ref); }
	void setf(const char *fmt, ... ) /* first is this ! ;) */
		__attribute__ ((format (printf, 2, 3)));
	void set(const char *x);
	void set(const char *x, int size);
	operator const char *() const { return ref; }
	bool operator *=(const Regex&);
	char *cstr() { return ref; }
	
	int strlen() const { return ::strlen(ref); }
	char *strchr(int c) { return ::strchr(ref, c); }
	
	friend String xf(const char *fmt, ... )
		__attribute__ ((__format__ (__printf__, 1, 2)));
};

inline bool operator ==(const String &l, const String &r)
{
	return strcmp(l, r) == 0;
}

inline bool operator ==(const String &l, const char *r)
{
	return strcmp(l, r) == 0;
}

inline bool operator ==(const char *l, const String &r)
{
	return strcmp(l, r) == 0;
}

inline bool operator !=(const String &l, const String &r)
{
	return strcmp(l, r) != 0;
}

inline bool operator !=(const String &l, const char *r)
{
	return strcmp(l, r) != 0;
}

inline bool operator !=(const char *l, const String &r)
{
	return strcmp(l, r) != 0;
}

inline bool operator <(const String &l, const String &r)
{
	return strcmp(l, r) < 0;
}

inline String operator + (const String &l, const String &r)
{
	String k;
	k.setf("%s%s", (const char*)l, (const char*)r);
	return k;
}

String cnv(double d, int bd = 4, int ad = 2);
String cnv(int n, int len = 5);
String cnv(const String &s, int len = -30);

#endif /* _V_UTILS_H */
